Subject: Re: [PATCH bpf-next 2/2] net: xdp: add xdp_update_skb_shared_info utility routine

From: Lorenzo Bianconi <[email-masked]>
Date: Fri, 16 Jul 2021 01:27:01 +0200

> Lorenzo Bianconi wrote:
> > > Lorenzo Bianconi wrote:
> > > > Introduce xdp_update_skb_shared_info routine to update frags array
> > > > metadata from a given xdp_buffer/xdp_frame. We do not need to reset
> > > > frags array since it is already initialized by the driver.
> > > > Rely on xdp_update_skb_shared_info in mvneta driver.
> > > 
> > > Some more context here would really help. I had to jump into the mvneta
> > > driver to see what is happening.
> > 
> > Hi John,
> > 
> > ack, you are right. I will add more context next time. Sorry for the noise.
> > 
> > > 
> > > So as I read this we have a loop processing the descriptor in
> > > mvneta_rx_swbm()
> > > 
> > >  mvneta_rx_swbm()
> > >    while (rx_proc < budget && rx_proc < rx_todo) {
> > >      if (rx_status & MVNETA_RXD_FIRST_DESC) ...
> > >      else {
> > >        mvneta_swbm_add_rx_fragment()
> > >      }
> > >      ..
> > >      if (!rx_status & MVNETA_RXD_LAST_DESC)
> > >          continue;
> > >      ..
> > >      if (xdp_prog)
> > >        mvneta_run_xdp(...)
> > >    }
> > > 
> > > roughly looking like above. First question, do you ever hit
> > > !MVNETA_RXD_LAST_DESC today? I assume this is avoided by hardware
> > > setup when XDP is enabled, otherwise _run_xdp() would be
> > > broken correct? Next question, given last descriptor bit
> > > logic whats the condition to hit the code added in this patch?
> > > wouldn't we need more than 1 descriptor and then we would
> > > skip the xdp_run... sorry lost me and its probably easier
> > > to let you give the flow vs spending an hour trying to
> > > track it down.
> > 
> > I will point it out in the new commit log, but this is a preliminary patch for
> > xdp multi-buff support. In the current codebase xdp_update_skb_shared_info()
> > is run just when the NIC is not running in XDP mode (please note
> > mvneta_swbm_add_rx_fragment() is run even if xdp_prog is NULL).
> > When we add xdp multi-buff support, xdp_update_skb_shared_info() will run even
> > in XDP mode since we will remove the MTU constraint.
> > 
> > In the current codebsae the following condition can occur in non-XDP mode if
> > the packet is split on 3 or more descriptors (e.g. MTU 9000):
> > 
> > if (!(rx_status & MVNETA_RXD_LAST_DESC))
> >    continue;
> 
> But, as is there is no caller of xdp_update_skb_shared_info() so
> I think we should move the these two patches into the series with
> the multibuf support.

mvneta is currently using it building the skb in mvneta_swbm_build_skb()
running in non-xdp mode but I am fine merging this series in the
multi-buff one.

> 
> > 
> > > 
> > > But, in theory as you handle a hardware discriptor you can build
> > > up a set of pages using them to create a single skb rather than a
> > > skb per descriptor. But don't we know if pfmemalloc should be
> > > done while we are building the frag list? Can't se just set it
> > > vs this for loop in xdp_update_skb_shared_info(),
> > 
> > I added pfmemalloc code in xdp_update_skb_shared_info() in order to reuse it
> > for the xdp_redirect use-case (e.g. whenever we redirect a xdp multi-buff
> > in a veth or in a cpumap). I have a pending patch where I am using
> > xdp_update_skb_shared_info in __xdp_build_skb_from_frame().
> 
> OK, but it adds an extra for loop and the related overhead. Can
> we avoid this overhead and just set it from where we first
> know we have a compound page. Or carry some bit through and
> do a simpler check,
> 
>  if (pfmemalloc_needed) skb->pfmemalloc = true;
> 
> I guess in the case here its building the skb so performance is maybe
> not as critical, but if it gets used in the redirect case then we
> shouldn't be doing unnecessary for loops.

doing so every driver will need to take care of it building the xdp_buff.
Does it work to do it since probably multi-buff is not critical for
performance?
In order to support xdp_redirect we need to save this info in
xdp_buff/xdp_frame, maybe in the flag field added in xdp multi-buff series.

> 
> > 
> > > 
> > > > +	for (i = 0; i < nr_frags; i++) {
> > > > +		struct page *page = skb_frag_page(&sinfo->frags[i]);
> > > > +
> > > > +		page = compound_head(page);
> > > > +		if (page_is_pfmemalloc(page)) {
> > > > +			skb->pfmemalloc = true;
> > > > +			break;
> > > > +		}
> > > > +	}
> > > > +}
> > > 
> > > ...
> > > 
> > > > diff --git a/drivers/net/ethernet/marvell/mvneta.c b/drivers/net/ethernet/marvell/mvneta.c
> > > > index 361bc4fbe20b..abf2e50880e0 100644
> > > > --- a/drivers/net/ethernet/marvell/mvneta.c
> > > > +++ b/drivers/net/ethernet/marvell/mvneta.c
> > > > @@ -2294,18 +2294,29 @@ mvneta_swbm_add_rx_fragment(struct mvneta_port *pp,
> > > >  	rx_desc->buf_phys_addr = 0;
> > > >  
> > > >  	if (data_len > 0 && xdp_sinfo->nr_frags < MAX_SKB_FRAGS) {
> > > > -		skb_frag_t *frag = &xdp_sinfo->frags[xdp_sinfo->nr_frags++];
> > > > +		skb_frag_t *frag = &xdp_sinfo->frags[xdp_sinfo->nr_frags];
> > > >  
> > > >  		skb_frag_off_set(frag, pp->rx_offset_correction);
> > > >  		skb_frag_size_set(frag, data_len);
> > > >  		__skb_frag_set_page(frag, page);
> > > > +		/* We don't need to reset pp_recycle here. It's already set, so
> > > > +		 * just mark fragments for recycling.
> > > > +		 */
> > > > +		page_pool_store_mem_info(page, rxq->page_pool);
> > > > +
> > > > +		/* first fragment */
> > > > +		if (!xdp_sinfo->nr_frags)
> > > > +			xdp_sinfo->gso_type = *size;
> > > 
> > > Would be nice to also change 'int size' -> 'unsigned int size' so the
> > > types matched. Presumably you really can't have a negative size.
> > > 
> > 
> > ack
> > 
> > > Also how about giving gso_type a better name. xdp_sinfo->size maybe?
> > 
> > I did it in this way in order to avoid adding a union in skb_shared_info.
> > What about adding an inline helper to set/get it? e.g.
> 
> What was wrong with the union?

Alex requested to use gso_* fields already there (the union was in the previous
version I sent).

Regards,
Lorenzo

> 
> > 
> > static inline u32 xdp_get_data_len(struct skb_shared_info *sinfo)
> > {
> >     return sinfo->gso_type;
> > }
> > 
> > static inline void xdp_set_data_len(struct skb_shared_info *sinfo, u32 datalen)
> > {
> >     sinfo->gso_type = datalen;
> > }
> > 
> > Regards,
> > Lorenzo
>